package org.iphsoft.simon1.ui;

import android.content.Context;
import android.graphics.Typeface;
import android.util.AttributeSet;
import android.widget.TextView;

import org.iphsoft.simon1.AndroidPortAdditions;
import org.iphsoft.simon1.AndroidPortAdditions.GameType;

public class IHNMDialogTextView extends TextView {

	public IHNMDialogTextView(Context context, AttributeSet attrs, int defStyle)
	{
		super(context, attrs, defStyle);

		init(context, attrs);
	}

	public IHNMDialogTextView(Context context, AttributeSet attrs)
	{
		super(context, attrs);

		init(context, attrs);
	}

	public IHNMDialogTextView(Context context)
	{
		super(context);

		init(context, null);
	}

	protected void init(Context context, AttributeSet attrs)
	{
		if (!isInEditMode())
		{
			// Set font
			Typeface tf = Typeface.createFromAsset(context.getAssets(), "digitall.ttf");
			setTypeface(tf);
		}
		
		setText(getText().toString().toUpperCase());
		setTextColor(0xfffeffed);
		setShadowLayer(4.0f, 0.0f, 0.0f, 0xff918c4c);
	}
	
	@Override
	public void setText(CharSequence text, BufferType type)
	{
		if (AndroidPortAdditions.GAME_TYPE == GameType.IHNM)
		{
			text = text.toString().toUpperCase();
		}
		
		super.setText(text, type);
	}


}
